package com.ibm.oti.reflect;

/*
 * Licensed Materials - Property of IBM,
 *    Copyright IBM Corp. 2005, 2010  All Rights Reserved
 */

import java.lang.annotation.Annotation;
import java.lang.ref.SoftReference;

public class Constructor {
	private java.lang.reflect.Constructor constructor;
	private SoftReference<Annotations> annotations;

public Constructor(java.lang.reflect.Constructor constructor) {
	this.constructor = constructor;
}

private synchronized Annotations getAnnotations() {
	Annotations ans;
	if (annotations == null || (ans = annotations.get()) == null) {
		annotations = new SoftReference<Annotations>(ans = new Annotations(AnnotationParser.parseAnnotations(constructor)));
	}
	return ans;
}

public <T extends Annotation> T getAnnotation(Class<T> cl) {
	if (cl == null) throw new NullPointerException();
	return getAnnotations().getAnnotation(cl);
}

public Annotation[] getDeclaredAnnotations() {
	return getAnnotations().getAnnotations().clone();
}

public Annotation[][] getParameterAnnotations() {
	return AnnotationParser.parseParameterAnnotations(constructor);
}

}
